//
//  KAddon.h
//  KEdit
//
//  Created by Karino, Masatsugu on Tue May 20 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
	KShellScriptType = 1,
	KAppleScriptType,
	KApplicationType,
	KOriginalBinaryType,
	KUndefinedScriptType
} KAddonContentType;

typedef enum {
	KReplaceSelection = 1,
	KReplaceAll,
	KNoTouch
} KAddonEditingType;


@interface KAddon : NSObject {
	KAddonContentType mAddonType;
	id mSource;
}


// initializers.
- (id)init;
- (id)initWithContentsOfFile:(NSString*)fileName;

+ (id)addon; // return an empty addon obj.
+ (id)addonWithContentsOfFile:(NSString*)fileName;

// check the object.
- (BOOL)isValid;

// execute script.
// if an error has occured, return nil; owtherwise return the edited string.
// type will be filled the editing type. if you pass it nil, it'll be ignored.
- (NSString*)runAddonFor:(NSString*)target 
			range:(NSRange)range 
			type:(KAddonEditingType*)type
			path:(NSString*)fileName; // Document path. If you pass it nil, it will be ignored.

// accessor methods.
- (KAddonContentType)addonType;
- (void)setAddonType:(KAddonContentType)type;
- (id)source;
- (void)setSource:(id)source;

// internal use.
- (NSString*)makeTmpFile:(NSString*)string;
- (NSString*)readTmpFile:(NSString*)fileName;
- (void)removeTmpFile:(NSString*)fileName;

- (void)dealloc;

@end
