/* KApplicationDel */

#import <Cocoa/Cocoa.h>

typedef enum {
  KRNMenuItemTag_HTMLTag = 100,
  KRNMenuItemTag_Bookmarks = 101,
  KRNMenuItemTag_Tools = 102
} KRNMenuItemTag;


@interface KApplicationDel : NSObject
{
	IBOutlet id myGotoLineWindow;
	IBOutlet id myGotoLineTextField;
  
  IBOutlet id myPopupMenuForTextView;

	id mSearchServer;
	id mPrefsServer;
	
	id mBookmarksMenu;
  id mHTMLTagsMenu;
  id mToolsMenu;
}

// Interface for outer objects.
- (void)showGotoLineWindow;
- (void)hideGotoLineWindow;

// NSApplication delegate methods.
- (void)applicationDidFinishLaunching:(NSNotification*)notification;


// accessing servers.
- (id)searchServer;
- (id)prefsServer;

- (id)popupMenuForTextView;

// get new allocated menus.
- (id)bookmarksMenu;
- (id)htmlTagsMenu;
- (id)toolsMenu;

// actions.
- (IBAction)openUserDefinedTagFile:(id)sender;

- (BOOL)userTagFileExists;

// internal use.
- (void)dealloc;

@end


@interface NSApplication (ScriptSupport)

// scripting.
- (void)handleCreateCommand:(NSScriptCommand*)command;

@end



