#import "KBottomView.h"
#import "KMenuUtils.h"
#import "MyDocument.h"
#import "KTextView.h"
#import "KStringUtils.h"
#import "KRangeObj.h"

@implementation KBottomView

- (NSMenu*)menuForEvent:(NSEvent*)theEvent
{
	NSMenu* menu = [[NSMenu alloc] initWithTitle:@""];
	id menuItem;
	NSString* string = [myTextView string];
	NSString* title;
	unsigned i, j;
	
	if([myDocument textType] == KDocumentTextFileFormat_CSS){
		//NSLog(@"css!");
		NSString* kTokenChars =  @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ.:";
		BOOL isInDef = YES;
		BOOL isInComment = NO;
		unsigned startOffset = 0;
		for(i = 0; i < [string length] - 1; i++){
			if([[string substringWithRange:NSMakeRange(i, 2)] isEqualToString:@"/*"]){
				isInComment = YES; i++; continue;
			}else if([[string substringWithRange:NSMakeRange(i, 2)] isEqualToString:@"*/"]){
				isInComment = NO; i++; continue;
			}else if(isInComment){ continue; }
			
			if([[string substringWithRange:NSMakeRange(i, 1)] isEqualToString:@"{"]){
				isInDef = NO;
			}else if([[string substringWithRange:NSMakeRange(i, 1)] isEqualToString:@"}"]){
				isInDef = YES;
			}else if(isInDef && [KStringUtils string:kTokenChars contains:[string substringWithRange:NSMakeRange(i, 1)]]){
				startOffset = i;
				NSArray* array = [[string substringWithRange:NSMakeRange(startOffset, [string length] - startOffset)] componentsSeparatedByString:@"{"];
				if([array count] >= 2){
					title = [array objectAtIndex:0];
					//NSLog(title);
					menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
					//[menuItem setAttachedObj:NSStringFromRange(NSMakeRange(startOffset, [title length]))];
					//[menuItem setAttachedObj:[KRangeObj rangeObjWithLocation:startOffset andLength:[title length]]];
                                        [menuItem setRepresentedObject:[KRangeObj rangeObjWithLocation:startOffset andLength:[title length]]];
                                        [menu addItem:menuItem];
				}else{
					break;
				}
				isInDef = NO;
			}
		}
	}else if([myDocument textType] == KDocumentTextFileFormat_KIndex){
		NSArray* array = [KStringUtils rangesOfLines:string range:NSMakeRange(0, [string length]) startsWith:@"@" ignoreCase:NO];
		for(i = 0; i < [array count]; i++){
			//title = [KStringUtils trimSpaces:[string substringWithRange:NSRangeFromString([array objectAtIndex:i])]];
			title = [KStringUtils trimSpaces:[string substringWithRange:[[array objectAtIndex:i] range]]];
			menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
			//[menuItem setAttachedObj:[array objectAtIndex:i]];
                        [menuItem setRepresentedObject:[array objectAtIndex:i]];
			[menu addItem:menuItem];
		}
	}else if([myDocument textType] == KDocumentTextFileFormat_Perl){
		NSArray* array = [KStringUtils rangesOfLines:string range:NSMakeRange(0, [string length]) startsWith:@"sub" ignoreCase:NO];
		NSArray* bufArray;
		for(i = 0; i < [array count]; i++){
			//title = [KStringUtils trimSpaces:[string substringWithRange:NSRangeFromString([array objectAtIndex:i])]];
			title = [KStringUtils trimSpaces:[string substringWithRange:[[array objectAtIndex:i] range]]];
			bufArray = [KStringUtils string:title bindedWith:@"sub" andWith:@"{"];
			if([bufArray count] == 1){
				title = [KStringUtils trimSpaces:[bufArray objectAtIndex:0]];
			}
			menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
			[menuItem setRepresentedObject:[array objectAtIndex:i]];
			[menu addItem:menuItem];
		}
	}else if([myDocument textType] == KDocumentTextFileFormat_Ruby){
		NSArray* classArray = [KStringUtils rangesOfLines:string range:NSMakeRange(0, [string length]) startsWith:@"class" ignoreCase:NO];
		NSArray* moduleArray = [KStringUtils rangesOfLines:string range:NSMakeRange(0, [string length]) startsWith:@"module" ignoreCase:NO];
		for(i = 0; i < [classArray count]; i++){
			title = [string substringWithRange:[[classArray objectAtIndex:i] range]];
			menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
			[menuItem setRepresentedObject:[classArray objectAtIndex:i]];
			[menu addItem:menuItem];
		}
		for(i = 0; i < [moduleArray count]; i++){
			title = [string substringWithRange:[[moduleArray objectAtIndex:i] range]];
			menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
			[menuItem setRepresentedObject:[moduleArray objectAtIndex:i]];
			[menu addItem:menuItem];
		}
	}else if([myDocument textType] == KDocumentTextFileFormat_Indexed){
		NSBundle* bundle = [NSBundle mainBundle];
		NSString* words = [NSString stringWithContentsOfFile:[bundle pathForResource:@"i-text_keywords" ofType:@"txt"]];
		NSArray* wordArray = [KStringUtils string:words componentsSeparatedByCharacters:@" \t\r\n,"];
		NSArray* lineArray;
		for(i = 0; i < [wordArray count]; i++){
			lineArray = [KStringUtils rangesOfLines:string range:NSMakeRange(0, [string length]) startsWith:[wordArray objectAtIndex:i] ignoreCase:NO];
			for(j = 0; j < [lineArray count]; j++){
				//title = [KStringUtils trimSpaces:[string substringWithRange:NSRangeFromString([lineArray objectAtIndex:j])]];
				title = [KStringUtils trimSpaces:[string substringWithRange:[[lineArray objectAtIndex:j] range]]];
				menuItem = [[NSMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
				[menuItem setRepresentedObject:[lineArray objectAtIndex:j]];
				[menu addItem:menuItem];
			}
		}
		
	}else if([myDocument textType] == KDocumentTextFileFormat_HTML){
		/*
		NSArray* array = [KStringUtils rangesOfString:string range:NSMakeRange(0, [string length]) startsWith:@"<h1" endsWith:@"</h1>"];
		NSArray* bufArray;
		for(i = 0; i < [array count]; i++){
			title = [KStringUtils trimSpaces:[string substringWithRange:NSRangeFromString([array objectAtIndex:i])]];
			bufArray = [KStringUtils string:title componentsSeparatedByCharacters:@">"];
			if([bufArray count] == 2){
				title = [KStringUtils trimSpaces:[bufArray objectAtIndex:2]];
			}
			menuItem = [[KMenuItem alloc] initWithTitle:title action:@selector(setSelectedRangeOfTextView:) keyEquivalent:@""];
			[menuItem setAttachedObj:[array objectAtIndex:i]];
			[menu addItem:menuItem];
		}*/
	}else{
		//do nothing now.
	}
	return menu;
}


@end










